#ifndef __UA_H__
#define __UA_H__


#define UA_DEBUG 1

#ifdef UA_DEBUG
#define UA_DEBUG_PRINTF sapi_logf
#else
#define UA_DEBUG_PRINTF(a, b...)
#endif


#define USER_AGENT "AAP-" SIPD_VERSION


typedef struct _ua_t {
	u8_t *str_local;
	u8_t *str_global;
	u8_t *str_proxy;
	address_t *local;
	address_t *global;
	address_t *last;
	url_t *proxy;
	const msg_t *inv;
	u32_t cseq;
} ua_t;


ua_t *ua_init(void);
void ua_free(ua_t *ua);
void ua_register(ua_t *ua, s32_t expires);


#endif /* __UA_H__ */
