#ifndef __CT_H__
#define __CT_H__


typedef enum _state_t {
	INVALID,
	TRYING,
	CALLING,
	PROCEEDING,
	COMPLETED
} state_t;


typedef struct {
	u8_t *hkey;
	state_t state;
	const tp_t *tp;
	const msg_t *req;
	const msg_t *ack;
	ctrans_resp_t respcb;
	ctrans_err_t errcb;
	void *arg;
	u8_t *sarg;
	u32_t ntx;
	u32_t nrefs;
	mutex_t mutex;
} ct_t;


ct_t *ct_alloc(void);
ct_t *ct_ref(ct_t *ct);
void ct_deref(void *arg);
void ct_set_state(ct_t *ct, state_t state);
state_t ct_get_state(ct_t *ct);
void ct_inc_ntx(ct_t *ct);
u32_t ct_get_ntx(ct_t *ct);


#endif /* __CT_H__ */
