#ifndef _IM_H_
#define _IM_H_


#define USER_AGENT "IM-" SIPD_VERSION


typedef struct {
        u8_t *str_local;
        u8_t *str_global;
        u8_t *str_proxy;
        address_t *local;
        address_t *global;
        address_t *remote;
        url_t *proxy;
        u32_t cseq;
} im_t;


im_t *im_init(void);
void im_free(im_t *im);
void im_set_remote(im_t *im, const u8_t *remote_str);
void im_register(im_t *im, s32_t expires);
void im_message(im_t *im, const address_t *addr, const u8_t *message);
void im_beep(im_t *im, const address_t *addr);
void gui_init(im_t *im);
void gui_msg(bool_t remote, const char *who, const char *text);
void gui_beep(const char *who);
void gui_log(const char *msg);


#endif /* _IM_H_ */
