#ifndef __CTRANS_H__
#define __CTRANS_H__


#define CTRANS_DEBUG 1

#ifdef CTRANS_DEBUG
#define CTRANS_DEBUG_PRINTF sapi_logf
#else
#define CTRANS_DEBUG_PRINTF(a, b...)
#endif


typedef void(*ctrans_resp_t)(const msg_t *req, const msg_t *resp, void *arg, u8_t *sarg);
typedef void(*ctrans_err_t)(const msg_t *req, const u8_t *reason, void *arg, u8_t *sarg);


void ctrans_init(void);
void ctrans_req(const tp_t *tp, const msg_t *req, ctrans_resp_t respcb, ctrans_err_t errcb, void *arg, const u8_t *sarg);
ret_t ctrans_resp(const msg_t *resp);
void ctrans_status(void);
u8_t *ctrans_status_str(void);


#endif /* __CTRANS_H__ */
