#ifndef __RTP_H__
#define __RTP_H__


#define RTP_DEBUG 1

#ifdef RTP_DEBUG
#define RTP_DEBUG_PRINTF sapi_logf
#else
#define RTP_DEBUG_PRINTF(a, b...)
#endif


typedef void(*rtp_recv_t)(void *payload, u32_t payload_size, void *arg);


void rtp_init(u16_t port, rtp_recv_t recv, void *arg);
void rtp_send(const u8_t *host, u16_t port, const void *payload, size_t payload_size, u8_t pt);
void rtp_status(void);


#endif /* __RTP_H__ */
