#ifndef __STRANS_H__
#define __STRANS_H__


#define STRANS_DEBUG 1

#ifdef STRANS_DEBUG
#define STRANS_DEBUG_PRINTF sapi_logf
#else
#define STRANS_DEBUG_PRINTF(a, b...)
#endif


typedef void(*strans_req_t)(const msg_t *req, const msg_t *oreq, const u8_t *hkey, const u8_t *ohkey, void *arg);
typedef void(*strans_err_t)(const u8_t *reason, void *arg);


void strans_init(void);
ret_t strans_req(const tp_t *tp, const msg_t *req, strans_req_t reqcb, strans_err_t errcb, void *arg);
void strans_resp(const u8_t *hkey, const msg_t *resp);
void strans_status(void);
u8_t *strans_status_str(void);


#endif /* __STRANS_H__ */


