#ifndef __TP_H__
#define __TP_H__


#define TP_DEBUG 1

#ifdef TP_DEBUG
#define TP_DEBUG_PRINTF sapi_logf
#else
#define TP_DEBUG_PRINTF(a, b...)
#endif


typedef enum {
	UDP,
	TCP
} proto_t;


typedef struct {
	u8_t *host;
	u16_t port;
	proto_t proto;
	u32_t nrefs;
	mutex_t mutex;
} tp_t;


typedef void(*tp_recv_t)(const tp_t *tp, const msg_t *msg, void *param);
typedef void(*tp_err_t)(const u8_t *reason, u8_t *sarg);


void tp_init(u16_t port, tp_recv_t recv, void *param);
tp_t *tp_alloc(void);
const tp_t *tp_ref(const tp_t *tp);
void tp_deref(const tp_t *tp);
void tp_send(const tp_t *tp, const msg_t *msg, tp_err_t err, const u8_t *sarg);
void tp_status(void);
u8_t *tp_status_str(void);
u8_t *tp_status_str_recv(void);
u8_t *tp_status_str_send(void);


#endif /* __TP_H__ */
