#include <sapi.h>
#include <msg.h>


cseq_t *msg_cseq_alloc()
{
	return((cseq_t *)sapi_malloc((u32_t)sizeof(cseq_t)));
}


void msg_cseq_free(cseq_t *cseq)
{
	if(!cseq)
		return;

	sapi_free(cseq->method);
	sapi_free(cseq);
}


ret_t msg_cseq_parse(cseq_t *cseq, const u8_t *cseq_str)
{
	u8_t *space, *end;

	if(!cseq || !cseq_str) {
		MSG_DEBUG_PRINTF("msg_cseq_parse(): cseq or cseq_str is NULL");
		return(ERR);
	}

	end   = (u8_t *)cseq_str + sapi_strlen(cseq_str);
	space = sapi_strchr(cseq_str, ' ');
	if(!space) {
		MSG_DEBUG_PRINTF("msg_cseq_parse(): Space is missing");
		return(ERR);
	}

	if((space - cseq_str < 1) || (end - space <= 1)){
		MSG_DEBUG_PRINTF("msg_cseq_parse(): number or method is missing");
		return(ERR);
	}

	if(sapi_to_number3(&(cseq->num), cseq_str, space - cseq_str) != OK) {
		MSG_DEBUG_PRINTF("msg_cseq_parse(): CSeq number is not numeric");
		return(ERR);
	}
	
	cseq->method = sapi_strdup(space + 1);

	return(OK);
}


u8_t *msg_cseq_str(const cseq_t *cseq)
{
	u8_t *str = NULL;

	if(!cseq || !cseq->method) {
		MSG_DEBUG_PRINTF("msg_cseq_str(): cseq or cseq->method is NULL");
		return(NULL);
	}

	sapi_saprintf(&str, "%i %s", cseq->num, cseq->method);

	return(str);
}
