#include <sapi.h>
#include <msg.h>


const static u8_t request_str[] = 
        "INVITE sip:richard@sxdesign.com SIP/2.0\r\n"
        "Via: SIP/2.0/UDP saturn.sxdesign.com:5061;branch=1st\r\n"
        "Via: SIP/2.0/UDP saturn.sxdesign.com:5060;branch=2nd\r\n"
        "To: Richard Aas <sip:richard@sxdesign.com>;tag=foo\r\n"
        "From: Edmund Hyggestund <sip:ed@sxdesign.com>;tag=FB0\r\n"
        "Contact: sip:foo@bar;asdf=asdadasdasdasddasd\r\n"
        "Call-ID: 1501083505@10.47.10.4\r\n"
        "CSeq: 1234 INVITE\r\n"
        "Max-Forwards: 70\r\n"
        "\r\n"
        "Some body...";


const static u8_t response_str[] = 
        "SIP/2.0 200 OK\r\n"
        "Via: SIP/2.0/UDP saturn.sxdesign.com:5060;branch=laskjblasib\r\n"
        "Via: SIP/2.0/UDP saturn.sxdesign.comx:50602;branch=laskjblasibxx\r\n"
        "To: Richard Aas <sip:richard@sxdesign.com>;tag=foo\r\n"
        "From: Edmund Hyggestund <sip:ed@sxdesign.com>;tag=FB0\r\n"
        "Contact: sip:foo@bar\r\n"
        "Call-ID: 1501083505@10.47.10.4\r\n"
        "CSeq: 1234 INVITE\r\n"
        "\r\n"
        "Some body...";


void parse_str(void)
{
	msg_t *msg, *dup;
	u8_t *str;

	// sapi_log_init();

	msg = msg_alloc();

	if(msg_parse(msg, request_str) != OK) {
		sapi_printf("Parse Error");
	}
	else {
		via_t *via = msg_via_create("somehost", 5060);
		msg_via_addparam(via, "branch", "0st");

		dup = msg_dup(msg);
		
		msg_dec_max_forwards(dup);
		msg_prepend_via(dup, via);
		msg_prepend_via(dup, via);
		msg_prepend_via(dup, via);
		msg_via_free(via);

		str = msg_str(dup);
		sapi_printf(str);
		sapi_free(str);
		msg_deref(dup);
	}

	msg_deref(msg);

	sapi_printf("Malloc: %i", sapi_nmalloced());
}


int main(void)
{
	parse_str();

	return(0);
}
