#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <signal.h>
#include "sapi.h"


#define MAXFD 64


/*
 * The purpose of this second fork is to guarantee
 * that the daemon cannot automatically acquire a
 * controlling terminal should it open a terminal
 * device in the future.
 *
 * Under SVR4, when a session leader without a
 * controlling terminal opens a terminal, the
 * terminal becomes controlling terminal of the
 * session leader.
 */
void sapi_daemon(void)
{
	u16_t i;

	if(fork())
		exit(0);

	setsid();

	signal(SIGHUP, SIG_IGN);

	if(fork())
		exit(0);

	chdir("/");
	umask(0);

	for(i=0; i<MAXFD; i++)
		close(i);
}
