#include <stdarg.h>
#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include "sapi.h"


ret_t sapi_fprintf(u32_t fd, const u8_t *fmt, ...)
{
	/* Guess we need no more than 100 bytes. */
	u32_t size = 100;
	s32_t n;
	u8_t *p;
	va_list ap;

	p = (u8_t *)sapi_malloc(size);

	for(;;) {

		/* Try to print in the allocated space. */
		va_start(ap, (const char *)fmt);
		n = vsnprintf((char *)p, (size_t)size, (const char *)fmt, ap);
		va_end(ap);

		/* If that worked, return the string. */
		if(n > -1 && n < size)
			break;

		/* Else try again with more space. */
		if(n > -1)           /* glibc 2.1 */
			size = n + 1; /* precisely what is needed */
		else                 /* glibc 2.0 */
			size *= 2;    /* twice the old size */
		p = (u8_t *)sapi_realloc((void *)p, size);
	}

	if(write((int)fd, (void *)p, (size_t)sapi_strlen(p)) < 0) {
		sapi_printf("sapi_fprint(): write(): %s", strerror(errno));
		sapi_free(p);
		return(ERR);
	}

	sapi_free(p);

	return(OK);
}
