#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <stdio.h>
#include "sapi.h"


#define MAX_LINE_LEN 8000


u8_t *sapi_freadline(u32_t fd)
{
	u8_t buf[MAX_LINE_LEN], *line, *line_end;
	size_t nread;

	nread = read((int)fd, (void *)buf, (size_t)(sizeof(buf) - 1));

	if(nread < 0) {
		sapi_printf("sapi_freadline(): read(): %s", strerror(errno));
		return(NULL);
	}

	buf[nread] = '\0';

	line_end = sapi_strchr(buf, '\n');
	if(!line_end)
		return(NULL);

	line = sapi_strndup(buf, line_end - buf);

	return(line);
}
