#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <string.h>
#include <stdio.h>
#include "sapi.h"


ret_t sapi_open(u32_t *fd, const u8_t *pathname, u8_t flags)
{
	s32_t lflags, lfd;
	mode_t lmode = S_IRUSR | S_IWUSR;

	if(flags == SAPI_READ)
		lflags = O_RDONLY;
	else if(flags == SAPI_WRITE)
		lflags = O_WRONLY | O_CREAT;


	lfd = open((char *)pathname, lflags, lmode);

	if(lfd < 0) {
		sapi_printf("sapi_open(): open(): %s: %s", pathname, strerror(errno));
		sapi_logf("sapi_open(): open(): %s: %s", pathname, strerror(errno));
		return(ERR);
	}

	*fd = (u32_t)lfd;

	return(OK);
}
