#include <stdarg.h>
#include <syslog.h>
#include <stdlib.h>
#include <stdio.h>
#include "sapi.h"


void sapi_printf(const u8_t *fmt, ...)
{
	/* Guess we need no more than 100 bytes. */
	s32_t n;
	u32_t size = 100;
	u8_t *p;
	va_list ap;

	if(!fmt)
		return;

	p = (u8_t *)sapi_malloc(size);

	for(;;) {

		/* Try to print in the allocated space. */
		va_start(ap, (char *)fmt);
		n = (s32_t)vsnprintf((char *)p, (size_t)size, (const char *)fmt, ap);
		va_end(ap);

		/* If that worked, return the string. */
		if(n > -1 && n < size)
			break;

		/* Else try again with more space. */
		if(n > -1)           /* glibc 2.1 */
			size = n + 1; /* precisely what is needed */
		else                 /* glibc 2.0 */
			size *= 2;    /* twice the old size */
		p = (u8_t *)sapi_realloc((void *)p, size);
	}

	// syslog(LOG_DAEMON | LOG_INFO, p);
	fprintf(stdout, "%s\n", p);
	fflush(stdout);

	sapi_free((void *)p);
}


void sapi_printf2(const u8_t *fmt, ...)
{
	/* Guess we need no more than 100 bytes. */
	s32_t n;
	u32_t size = 100;
	u8_t *p;
	va_list ap;

	if(!fmt)
		return;

	p = (u8_t *)sapi_malloc(size);

	for(;;) {

		/* Try to print in the allocated space. */
		va_start(ap, (char *)fmt);
		n = (s32_t)vsnprintf((char *)p, (size_t)size, (const char *)fmt, ap);
		va_end(ap);

		/* If that worked, return the string. */
		if(n > -1 && n < size)
			break;

		/* Else try again with more space. */
		if(n > -1)           /* glibc 2.1 */
			size = n + 1; /* precisely what is needed */
		else                 /* glibc 2.0 */
			size *= 2;    /* twice the old size */
		p = (u8_t *)sapi_realloc((void *)p, size);
	}

	// syslog(LOG_DAEMON | LOG_INFO, p);
	fprintf(stdout, "%s", p);
	fflush(stdout);

	sapi_free((void *)p);
}
