#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <stdio.h>
#include "sapi.h"


#define LISTENQ 20


ret_t sapi_tcp_listen(u32_t *fd, u16_t port)
{
	struct sockaddr_in sa;

	if(!fd)
		return(ERR);

	if((*fd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
		sapi_printf("sapi_udp_listen(): socket(): %s", strerror(errno));
		sapi_logf("sapi_udp_listen(): socket(): %s", strerror(errno));
		return(ERR);
	}

	bzero(&(sa), sizeof(sa));
	sa.sin_family = AF_INET;
	sa.sin_addr.s_addr = htonl(INADDR_ANY);
	sa.sin_port = htons((unsigned short int)port);

	if(bind(*fd, (struct sockaddr *)&sa, (socklen_t)sizeof(sa)) < 0) {
		sapi_printf("sapi_tcp_listen(): bind(): %s", strerror(errno));
		sapi_logf("sapi_tcp_listen(): bind(): %s", strerror(errno));
		return(ERR);
	}

	if(listen((int)*fd, (int)LISTENQ) < 0) {
		sapi_printf("sapi_tcp_listen(): listen(): %s", strerror(errno));
		sapi_logf("sapi_tcp_listen(): listen(): %s", strerror(errno));
		return(ERR);
	}

	sapi_printf("Server listening on TCP port %i", (int)port);
	sapi_logf("Server listening on TCP port %i", (int)port);

	return(OK);
}
