#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <stdio.h>
#include "sapi.h"


#define BUFFER_SIZE 8000


void sapi_udp_listen(u16_t port, sapicb_udp_listen cb)
{
	int fd, size;
	struct sockaddr_in sa, ca;
	socklen_t ca_len = sizeof(ca);
	char buf[BUFFER_SIZE];

	if((fd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
		sapi_printf("sapi_udp_listen(): socket(): %s", strerror(errno));
		return;
	}

	bzero(&(sa), sizeof(sa));
	sa.sin_family = AF_INET;
	sa.sin_addr.s_addr = htonl(INADDR_ANY);
	sa.sin_port = htons((unsigned short int)port);

	if(bind(fd, (struct sockaddr *)&sa, (socklen_t)sizeof(sa)) < 0) {
		sapi_printf("sapi_udp_listen(): bind(): %s", strerror(errno));
		return;
	}

	sapi_printf("Server listening on UDP port %i", (int)port);

	for(;;) {
		size = recvfrom(fd, buf, sizeof(buf) - 1, 0, (struct sockaddr *)&ca, &ca_len);
		buf[size] = '\0';
		if(cb) {
			cb(buf);
		}
	}
}


void sapi_udp_listen2(u32_t *fd, u16_t port)
{
	struct sockaddr_in sa;

	if(!fd)
		return;

	if((*fd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
		sapi_printf("sapi_udp_listen(): socket(): %s", strerror(errno));
		return;
	}

	bzero(&(sa), sizeof(sa));
	sa.sin_family = AF_INET;
	sa.sin_addr.s_addr = htonl(INADDR_ANY);
	sa.sin_port = htons((unsigned short int)port);

	if(bind(*fd, (struct sockaddr *)&sa, (socklen_t)sizeof(sa)) < 0) {
		sapi_printf("sapi_udp_listen(): bind(): %s", strerror(errno));
		return;
	}

	sapi_printf("Server listening on UDP port %i", (int)port);
}
