#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <stdio.h>
#include "sapi.h"


void sapi_udp_send(const u8_t *host, const u16_t port, const void *payload, u32_t len)
{
	int fd;
	struct sockaddr_in sa;
	u32_t addr;

	if(!host || !payload)
		return;

	if(sapi_resolv(host, &addr) == ERR)
		return;

	if((fd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
		sapi_logf("sapi_udp_send(): socket(): %s", strerror(errno));
		return;
	}

	bzero((void *)&sa, sizeof(sa));
	sa.sin_family = AF_INET;
	sa.sin_port   = htons((unsigned short int)port);
	sa.sin_addr.s_addr = addr;

	if(sendto(fd, payload, (size_t)len, 0, (struct sockaddr *)&sa, (socklen_t)sizeof(sa)) < 0) {
		sapi_logf("sapi_udp_send(): sendto(): %s\n", strerror(errno));
		close(fd);
		return;
	}

	close(fd);
}
