/**
 * @file media.h Internal SDP defines.
 *
 * Copyright 2002-2003 SX Design AS <www.sxdesign.com>.  All rights reserved.
 */
#ifndef MEDIA_H__
#define MEDIA_H__


/*
 * Constants
 */
#define SDP_VERSION "0"      /**< The version of SDP we are supporting. */


#define SDP_DEBUG_ENABLED 1


/**
 * Module specific frontend debug macro, see DEBUGFx() in libUtils module.
 */
#ifdef SDP_DEBUG_ENABLED
#define SDP_DEBUGFx(a, b...)  sapi_logf("sdp: " a, ## b)
#else
#define SDP_DEBUGFx(a, b...)
#endif


/*
 * Prototypes
 */
sdp_media_t *media_alloc(void);
void media_free(sdp_media_t *m);
ret_t media_parse(sdp_media_t *media, const u8_t *body);
ret_t media_parse_attrib(sdp_media_t *media, const u8_t *body);
void media_str(sdp_media_t *media, u8_t *body);


#endif /* MEDIA_H__ */
