#include <sapi.h>
#include <msg.h>
#include <tp.h>
#include <ctrans.h>
#include <strans.h>
#include <ldb.h>
#include "sipd.h"


static ret_t add_contacts(void *value, u32_t n, void *arg1, void *arg2)
{
	address_t *contact = (address_t *)value;
	msg_t *resp = (msg_t *)arg1;

	if(!contact || !resp) {
		SIPD_DEBUG_PRINTF("add_contacts(): contact or resp is NULL");
		return(ERR);
	}

	msg_add_contact(resp, contact);

	return(OK);
}


void sipd_registrar(const msg_t *req, const u8_t *hkey)
{
	msg_t *resp;

	/* Location Database */
	if(req->contacts && (ldb_put(req) != OK)) {

		resp = msg_response(req, "500", "Internal Server Error");
	}
	else {
		u8_t *addr = msg_url_cannonical(req->to->url);
		list_t *contacts = ldb_get(addr);
		
		sapi_free(addr);
		
		resp = msg_response(req, "200", "OK");

		if(contacts) {
			sapi_list_apply(contacts, add_contacts, resp, NULL);
			sapi_list_free(contacts, msg_address_free);
		}
	}

	strans_resp(hkey, resp);
	msg_deref(resp);
}
