#ifndef __SIPD_H__
#define __SIPD_H__


#define SIPD_DEBUG 1

#ifdef SIPD_DEBUG
#define SIPD_DEBUG_PRINTF sapi_logf
#else
#define SIPD_DEBUG_PRINTF(a, b...)
#endif


#define SIPD_MAX_FORWARDS (70)


typedef struct {
	url_t *url;
	u8_t *domain;
	u32_t start_time;
	bool_t stateless;
} sipd_t;


sipd_t *sipd_init(void);
void sipd_free(sipd_t *sipd);
void sipd_registrar(const msg_t *req, const u8_t *hkey);
void sipd_proxy_init(void);
void sipd_proxy(const sipd_t *sipd, const msg_t *ireq, const u8_t *hkey);
void sipd_proxy_cancel(const sipd_t *sipd, const msg_t *req, const msg_t *oreq, const u8_t *hkey, const u8_t *ohkey);
void sipd_proxy_sl_req(const sipd_t *sipd, const msg_t *ireq);
ret_t sipd_proxy_sl_resp(const sipd_t *sipd, const msg_t *iresp);


#endif /* __SIPD_H__ */
