#ifndef __ST_H__
#define __ST_H__


typedef enum _state_t {
	INVALID,
        PROCEEDING,
        TRYING,
        COMPLETED,
        CONFIRMED
} state_t;


typedef struct {
        u8_t *hkey;
        state_t state;
        const tp_t *tp;
        const msg_t *req;
        const msg_t *resp;
        strans_req_t reqcb;
        strans_err_t errcb;
        void *arg;
	u32_t ntx;
	u32_t nrefs;
	mutex_t mutex;
} st_t;


st_t *st_alloc(void);
st_t *st_ref(st_t *st);
void st_deref(void *arg);
void st_set_state(st_t *st, state_t state);
state_t st_get_state(st_t *st);
void st_inc_ntx(st_t *st);
u32_t st_get_ntx(st_t *st);


#endif /* __CT_H__ */
