#include <unistd.h>
#include <sapi.h>
#include <msg.h>


static fifo_t *__queue = NULL;


static void *cons(void *arg)
{
	while(__queue) {

		const msg_t *msg = sapi_fifo_get(__queue);

		msg_deref(msg);
	}	

	return(NULL);
}


static void *prod(void *arg)
{
	while(__queue) {

		msg_t *msg = msg_alloc();

		sapi_fifo_put(__queue, msg_ref(msg));

		msg_deref(msg);
	}

	return(NULL);
}


int main(void)
{	
	pthread_t t1, t2, t3;

	__queue = sapi_fifo_alloc();

	pthread_create(&t1, NULL, prod, NULL);
	pthread_create(&t2, NULL, cons, NULL);
	pthread_create(&t3, NULL, cons, NULL);

	for(;;) {
		sapi_printf("Memory Allocation: %i\n", sapi_nmalloced());
		sleep(1);
	}

	return(0);
}
