#ifndef __UA_H__
#define __UA_H__


#define UA_DEBUG 1

#ifdef UA_DEBUG
#define UA_DEBUG_PRINTF sapi_logf
#else
#define UA_DEBUG_PRINTF(a, b...)
#endif


#define USER_AGENT "UA-" SIPD_VERSION
#define RTP_PORT (5004)


typedef struct _ua_t {
	u8_t *str_local;
	u8_t *str_global;
	u8_t *str_proxy;
	address_t *local;
	address_t *global;
	address_t *last;
	url_t *proxy;
	const msg_t *inv;
	u32_t cseq;
} ua_t;


ua_t *ua_init(void);
void ua_free(ua_t *ua);
void ua_register(ua_t *ua, s32_t expires);
void ua_invite(ua_t *ua, const address_t *addr);
void ua_bye(ua_t *ua, const address_t *addr);
void ua_cancel(ua_t *ua);
void ua_message_send(ua_t *ua, const address_t *addr);
void ua_message_recv(const msg_t *req);
address_t *ua_input_address(ua_t *ua);
void ua_test(ua_t *ua, const address_t *addr, const u8_t *method);


#endif /* __UA_H__ */
